# This specfile was generated automatically.
# If something needs to be changed - please contact Anders Waananen <waananen@nbi.dk>
# to make sure the changes gets added upstream.

%define _prefix /opt/globus

Summary: Globus binary package openldap version 2.0.22 with patches
Name: globus_openldap
Version: 0.13
Release: 0.7%{?dist}
Group: Globus/MDS
License: Apache License
Url: http://www.globus.org/
Source: %{name}-%{version}.tar.gz
Prefix: %{_prefix}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Patch: globus_openldap.patch
Patch1: globus_openldap-db4.patch
Patch2: globus_openldap-extrafiles.patch
Patch3: globus_openldap-ldifsyntax.patch
Patch4: globus_openldap-nosasl.patch
Patch5: globus_openldap-perms.patch
BuildRequires: globus_openssl >= 1
BuildRequires: globus_openssl-devel
BuildRequires: globus_libtool >= 1
BuildRequires: globus_libtool-devel
BuildRequires: gpt
BuildRequires: globus_core
BuildRequires: globus_core-devel
Requires: globus_libtool >=  1

%package devel
Summary: Development files for Globus binary package openldap version 2.0.22 with patches
Group: Globus/MDS
Requires: globus_openldap = %{version}
Requires: globus_openssl-devel >= 1
Requires: globus_libtool-devel >= 1

%ifarch x86_64 alpha
%define flavor gcc64pthr
%else
%define flavor gcc32pthr
%endif

%description
Globus binary package openldap version 2.0.22 with patches

%description devel
Globus binary package openldap version 2.0.22 with patches
This package contains files needed for development.

%prep
%setup -q
%patch -p0
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
cd openldap-*
cp -p configure configure.orig
cat configure.orig | \
    sed -e 's!^prefix=.$(GLOBUS_LOCATION).*!prefix=%{_prefix}!' \
        -e 's!^exec_prefix=.$(GLOBUS_LOCATION).*!exec_prefix=%{_prefix}!' \
         > configure
rm -f configure.orig

for i in configure*
do
  cp -p $i orig.$i
  cat orig.$i | \
      sed -e 's!^ac_default_prefix=/usr/local.*!ac_default_prefix=%{_prefix}!' \
          > $i
  rm -f orig.$i
done

for i in `find . -name Makefile.in`
do
  cp -p $i $i.orig
  sed -e 's!\(^[a-zA-Z_]*\) = \$[({]GLOBUS_LOCATION[)}]!\1 = $(prefix)!' < $i.orig > $i
done


%build
flavor=%{flavor}
rm -rf $RPM_BUILD_ROOT

# Create build directory so it's not deleted after the build
mkdir BUILD

#
# Files will not be install in GLOBUS_LOCATION, but it must be set
# in order to find libtool-<flavor>. and maybe other stuff
#

if test -z "$GLOBUS_LOCATION"; then

  for i in `echo $PATH | tr : ' '` /opt/globus/sbin; do
    if test -f $i/libtool-$flavor; then
      export GLOBUS_LOCATION=`dirname $i`
      break
    fi
  done

  if test -z "$GLOBUS_LOCATION"; then
    export GLOBUS_LOCATION=/opt/globus
    echo "Warning: Could not determine GLOBUS_LOCATION - using $GLOBUS_LOCATION"
  fi

fi


#
# Guess GPT_LOCATION
#

unset GPT_LOCATION
for i in `echo $PATH | tr : ' '` /opt/gpt/sbin; do
  if test -f $i/gpt-build; then
    export GPT_LOCATION=`dirname $i`
    break
  fi
done

if test -z "$GPT_LOCATION"; then
  echo "Could not determine GPT_LOCATION"
  exit 1
fi


#
# First we hide the filelist from GPT so it will not try to generate
# filelists and metadata (we do this manually)
#
mv filelist filelist.hidden

#
# Flavor the filelist (include files and libraries)
#

cp -p filelist.hidden filelist.old
cat filelist.old |\
    sed -e "s,lib/lib\([a-z0-9_]*\),lib/lib\1_${flavor}," \
        -e "s,include/,include/${flavor}/," > filelist.hidden

#
# Generate metadata files
#

$GPT_LOCATION/sbin/gpt_generate_bin_pkg_data -flavor=${flavor} pkg_data_src.gpt

#
# Generate filelists
#

$GPT_LOCATION/sbin/gpt_sort_filelist -flavor=${flavor} -pkg=pkg_data_src.gpt filelist.hidden

#
# Use the right prefix in the filelist (usually /opt/globus)
#

for i in ${flavor}*.filelist noflavor*.filelist
do
  sub=`basename $i .filelist`
  (
  echo "etc/globus_packages/%{name}/$sub.filelist"
  echo "etc/globus_packages/%{name}/pkg_data_$sub.gpt"
  ) >> $i
  cp -p $i $i.orig
#  sed "s!^!%{prefix}/!" < $i.orig > $i
  sed 's!^!/!' < $i.orig > $i
done

#
# The actual build
#

$GPT_LOCATION/sbin/gpt-build -verbose --srcdir=`pwd` ${flavor}

#
# Remove prefix in filelists if it exists. It will usually be there
# if GLOBUS_LOCATION != /opt/globus
#

for i in pkgdata/*filelist
do
  if test -r "$i"
  then
    cp -p $i $i.orig
    sed "s!^%{_prefix}!!" < $i.orig > $i
    rm -f $i.orig
  fi
done

#
# Create RPM filelists
#

# Non-dev files
(
 for j in {pkgdata/,}${flavor}_{pgm,rtl}.filelist {pkgdata/,}noflavor_{data,doc,pgm}.filelist
 do
   test -r $j && cat $j
 done
) | sed -e 's,globus_packages,gpt/packages,' | sort | uniq > package.filelist

# Dev files
(
 for j in {pkgdata/,}${flavor}_dev.filelist {pkgdata/,}noflavor_dev.filelist
 do
   test -r $j && cat $j
 done
) | sed -e 's,globus_packages,gpt/packages,' | sort | uniq > package-devel.filelist

# Add prefix to RPM filelists

for j in package.filelist package-devel.filelist
do
  cp -p $j $j.orig
  sed "s!^!%{_prefix}!" < $j.orig > $j
  rm -f $j.orig
done

%install

flavor=%{flavor}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages
( cd $RPM_BUILD_ROOT%{_prefix}/etc ; ln -s gpt/packages globus_packages)

unset GPT_LOCATION
for i in `echo $PATH | tr : ' '` /opt/gpt/sbin; do
  if test -f $i/gpt-build; then
    export GPT_LOCATION=`dirname $i`
    break
  fi
done

if test -z "$GPT_LOCATION"; then
  echo "Could not determine GPT_LOCATION"
  exit 1
fi


#
# GLOBUS_LOCATION is not needed for installation, but must be set,
# in order to find libtool-<flavor>. and maybe other stuff
#

if test -z "$GLOBUS_LOCATION"; then

  for i in `echo $PATH | tr : ' '` /opt/globus/sbin; do
    if test -f $i/libtool-$flavor; then
      export GLOBUS_LOCATION=`dirname $i`
      break
    fi
  done

  if test -z "$GLOBUS_LOCATION"; then
    echo "Could not determine GLOBUS_LOCATION"
    exit 1
  fi

fi

mkdir -p $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/
cp -p ${flavor}*.filelist noflavor*.filelist pkg_data_${flavor}*.gpt pkg_data_noflavor*.gpt $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/
cd openldap-*/
make install DESTDIR=$RPM_BUILD_ROOT

#
# Flavor headers
#

mv $RPM_BUILD_ROOT%{prefix}/include $RPM_BUILD_ROOT%{prefix}/${flavor}
mkdir $RPM_BUILD_ROOT%{prefix}/include/
mv $RPM_BUILD_ROOT%{prefix}/${flavor} $RPM_BUILD_ROOT%{prefix}/include
cd ..

#
# Fix .la files:
# - Change libs from %{_prefix}/libmylib.la to -L%{_prefix} -lmylib
# - Hardwire prefix to %{_prefix} instead of GLOBUS_LOCATION used at build time
#

echo "Fixing paths in .la files"

for i in $RPM_BUILD_ROOT%{_prefix}/lib*/lib*.la
do
  if test -r "$i"
  then
  cp -p $i $i.oldcopy
  sed -e "s!%{_prefix}/lib/lib\([a-zA-Z0-9._]*\).la!-l\1!g" \
      -e "s!$GLOBUS_LOCATION!%{_prefix}!g" < $i.oldcopy     \
       > $i
  rm -f $i.oldcopy
  fi
done

#
# Well the above might be good in some realities - but delete the stuff and
# remove from filelists.
# Note: Only remove .la files in /opt/globus/lib since /opt/globus/libexec/openldap
#       has required .la files for loadable modules
#
test -d $RPM_BUILD_ROOT%{_prefix}/lib && \
find $RPM_BUILD_ROOT%{_prefix}/lib -name 'lib*.la' -exec rm -rfv '{}' \;
for i in package*.filelist $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/*filelist
do
  cp -p $i $i.orig
  grep -v 'lib/.*\.la$' < $i.orig > $i || :
  rm -f $i.orig
done

#
# Fix GPT filelists:
# - Remove DESTDIR/%{_prefix}
#

# for i in $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/*filelist
# do
#   cp -p $i $i.orig
#   sed "s!^$RPM_BUILD_ROOT%{_prefix}!!" < $i.orig > $i
#   rm -f $i.orig
# done

#
# Remove metadata files for empty packages or pgm_static packages
# (an empty package is a package with <= 2 files)
#

for i in {pkgdata,.}/noflavor*.filelist {pkgdata,.}/${flavor}*.filelist
do
  if test -r "$i"; then
  nf=`wc -l < $i|tr -d ' '` 
  if test $nf -le 2 -o `basename $i` = ${flavor}_pgm_static.filelist \
                     -o `basename $i` = noflavor_pgm_static.filelist
  then
    pn=`basename $i .filelist`
    echo Removing metadata files in filelist for package $pn
    for p in package package-devel
    do
      mv $p.filelist $p.filelist.old
      cat $p.filelist.old | egrep -v "$pn.(filelist|gpt)$" > $p.filelist || :
    done
    echo Removing files - if any
    rm -fv $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/$pn.filelist
    rm -fv $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/pkg_data_$pn.gpt
  fi
  fi
done

#
# Remove metadata files which have been installed, but have no associated filelists
#

for i in $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/pkg_data_*gpt
do
  p=`basename $i .gpt |sed 's/^pkg_data_//'`
  test -r $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/$p.filelist || rm -f $i
done
#
# Remove unpackaged files
#

rm -f $RPM_BUILD_ROOT%{_prefix}/etc/gpt/packages/%{name}/*.format

echo "%{_prefix}/etc/globus_packages" >> package.filelist

echo "%dir %{_prefix}/etc/gpt/packages/%{name}" >> package.filelist

%clean
rm -rf $RPM_BUILD_ROOT

%files -f package.filelist
%defattr(-,root,root,-)

%files -f package-devel.filelist devel
%defattr(-,root,root,-)

%changelog
* Fri Jun 29 2007 Anders Waananen <waananen@nbi.dk> - 0.13-0.7%{?dist}
- Autogenerated
